import 'package:customize/customize.dart';
import 'package:flutter/material.dart';

///Text colors extension to directly color Text
extension TextColorExtension on Text {
  /// Main Color
  Text get primary => _copyWith(color: FxColors.primary);
  Text get success => _copyWith(color: FxColors.success);
  Text get warning => _copyWith(color: FxColors.warning);
  Text get danger => _copyWith(color: FxColors.danger);
  Text get info => _copyWith(color: FxColors.info);
  Text get dark => _copyWith(color: FxColors.dark);
  Text get light => _copyWith(color: FxColors.light);
  Text get white => _copyWith(color: Colors.white);
  Text get black => _copyWith(color: Colors.black);

  ///Light Main Colors
  Text get primaryLight => _copyWith(color: FxColors.primaryLight);
  Text get successLight => _copyWith(color: FxColors.successLight);
  Text get infoLight => _copyWith(color: FxColors.infoLight);
  Text get warningLight => _copyWith(color: FxColors.warningLight);
  Text get dangerLight => _copyWith(color: FxColors.dangerLight);

  ///Text Colors
  Text get textColor => _copyWith(color: FxColors.textColor);
  Text get labelColor => _copyWith(color: FxColors.labelColor);
  Text get disabledColor => _copyWith(color: FxColors.disabledColor);
  Text get textFieldColor => _copyWith(color: FxColors.textFieldColor);

  ///Status Colors
  Text get statusWarningColor => _copyWith(color: FxColors.statusWarningColor);
  Text get statusDangerColor => _copyWith(color: FxColors.statusDangerColor);
  Text get statusSuccessColor => _copyWith(color: FxColors.statusSuccessColor);

  ///Light Status Colors
  Text get statusWarningLightColor =>
      _copyWith(color: FxColors.statusWarningLightColor);
  Text get statusDangerLightColor =>
      _copyWith(color: FxColors.statusDangerLightColor);
  Text get statusSuccessLightColor =>
      _copyWith(color: FxColors.statusSuccessLightColor);

  ///Gray Colors
  Text get gray50 => _copyWith(color: FxColors.gray50);
  Text get gray100 => _copyWith(color: FxColors.gray100);
  Text get gray200 => _copyWith(color: FxColors.gray200);
  Text get gray300 => _copyWith(color: FxColors.gray300);
  Text get gray400 => _copyWith(color: FxColors.gray400);
  Text get gray500 => _copyWith(color: FxColors.gray500);
  Text get gray600 => _copyWith(color: FxColors.gray600);
  Text get gray700 => _copyWith(color: FxColors.gray700);
  Text get gray800 => _copyWith(color: FxColors.gray800);
  Text get gray900 => _copyWith(color: FxColors.gray900);

  ///Blue Gray Colors
  Text get blueGray50 => _copyWith(color: FxColors.blueGray50);
  Text get blueGray100 => _copyWith(color: FxColors.blueGray100);
  Text get blueGray200 => _copyWith(color: FxColors.blueGray200);
  Text get blueGray300 => _copyWith(color: FxColors.blueGray300);
  Text get blueGray400 => _copyWith(color: FxColors.blueGray400);
  Text get blueGray500 => _copyWith(color: FxColors.blueGray500);
  Text get blueGray600 => _copyWith(color: FxColors.blueGray600);
  Text get blueGray700 => _copyWith(color: FxColors.blueGray700);
  Text get blueGray800 => _copyWith(color: FxColors.blueGray800);
  Text get blueGray900 => _copyWith(color: FxColors.blueGray900);

  ///Cool Gray Colors
  Text get coolGray50 => _copyWith(color: FxColors.coolGray50);
  Text get coolGray100 => _copyWith(color: FxColors.coolGray100);
  Text get coolGray200 => _copyWith(color: FxColors.coolGray200);
  Text get coolGray300 => _copyWith(color: FxColors.coolGray300);
  Text get coolGray400 => _copyWith(color: FxColors.coolGray400);
  Text get coolGray500 => _copyWith(color: FxColors.coolGray500);
  Text get coolGray600 => _copyWith(color: FxColors.coolGray600);
  Text get coolGray700 => _copyWith(color: FxColors.coolGray700);
  Text get coolGray800 => _copyWith(color: FxColors.coolGray800);
  Text get coolGray900 => _copyWith(color: FxColors.coolGray900);

  ///True Gray Colors
  Text get trueGray50 => _copyWith(color: FxColors.trueGray50);
  Text get trueGray100 => _copyWith(color: FxColors.trueGray100);
  Text get trueGray200 => _copyWith(color: FxColors.trueGray200);
  Text get trueGray300 => _copyWith(color: FxColors.trueGray300);
  Text get trueGray400 => _copyWith(color: FxColors.trueGray400);
  Text get trueGray500 => _copyWith(color: FxColors.trueGray500);
  Text get trueGray600 => _copyWith(color: FxColors.trueGray600);
  Text get trueGray700 => _copyWith(color: FxColors.trueGray700);
  Text get trueGray800 => _copyWith(color: FxColors.trueGray800);
  Text get trueGray900 => _copyWith(color: FxColors.trueGray900);

  ///Warm Gray Colors
  Text get warmGray50 => _copyWith(color: FxColors.warmGray50);
  Text get warmGray100 => _copyWith(color: FxColors.warmGray100);
  Text get warmGray200 => _copyWith(color: FxColors.warmGray200);
  Text get warmGray300 => _copyWith(color: FxColors.warmGray300);
  Text get warmGray400 => _copyWith(color: FxColors.warmGray400);
  Text get warmGray500 => _copyWith(color: FxColors.warmGray500);
  Text get warmGray600 => _copyWith(color: FxColors.warmGray600);
  Text get warmGray700 => _copyWith(color: FxColors.warmGray700);
  Text get warmGray800 => _copyWith(color: FxColors.warmGray800);
  Text get warmGray900 => _copyWith(color: FxColors.warmGray900);

  ///Red Colors
  Text get red50 => _copyWith(color: FxColors.red50);
  Text get red100 => _copyWith(color: FxColors.red100);
  Text get red200 => _copyWith(color: FxColors.red200);
  Text get red300 => _copyWith(color: FxColors.red300);
  Text get red400 => _copyWith(color: FxColors.red400);
  Text get red500 => _copyWith(color: FxColors.red500);
  Text get red600 => _copyWith(color: FxColors.red600);
  Text get red700 => _copyWith(color: FxColors.red700);
  Text get red800 => _copyWith(color: FxColors.red800);
  Text get red900 => _copyWith(color: FxColors.red900);

  ///Orange Colors
  Text get orange50 => _copyWith(color: FxColors.orange50);
  Text get orange100 => _copyWith(color: FxColors.orange100);
  Text get orange200 => _copyWith(color: FxColors.orange200);
  Text get orange300 => _copyWith(color: FxColors.orange300);
  Text get orange400 => _copyWith(color: FxColors.orange400);
  Text get orange500 => _copyWith(color: FxColors.orange500);
  Text get orange600 => _copyWith(color: FxColors.orange600);
  Text get orange700 => _copyWith(color: FxColors.orange700);
  Text get orange800 => _copyWith(color: FxColors.orange800);
  Text get orange900 => _copyWith(color: FxColors.orange900);

  ///Amber Colors
  Text get amber50 => _copyWith(color: FxColors.amber50);
  Text get amber100 => _copyWith(color: FxColors.amber100);
  Text get amber200 => _copyWith(color: FxColors.amber200);
  Text get amber300 => _copyWith(color: FxColors.amber300);
  Text get amber400 => _copyWith(color: FxColors.amber400);
  Text get amber500 => _copyWith(color: FxColors.amber500);
  Text get amber600 => _copyWith(color: FxColors.amber600);
  Text get amber700 => _copyWith(color: FxColors.amber700);
  Text get amber800 => _copyWith(color: FxColors.amber800);
  Text get amber900 => _copyWith(color: FxColors.amber900);

  ///Yellow Colors
  Text get yellow50 => _copyWith(color: FxColors.yellow50);
  Text get yellow100 => _copyWith(color: FxColors.yellow100);
  Text get yellow200 => _copyWith(color: FxColors.yellow200);
  Text get yellow300 => _copyWith(color: FxColors.yellow300);
  Text get yellow400 => _copyWith(color: FxColors.yellow400);
  Text get yellow500 => _copyWith(color: FxColors.yellow500);
  Text get yellow600 => _copyWith(color: FxColors.yellow600);
  Text get yellow700 => _copyWith(color: FxColors.yellow700);
  Text get yellow800 => _copyWith(color: FxColors.yellow800);
  Text get yellow900 => _copyWith(color: FxColors.yellow900);

  ///Lime Colors
  Text get lime50 => _copyWith(color: FxColors.lime50);
  Text get lime100 => _copyWith(color: FxColors.lime100);
  Text get lime200 => _copyWith(color: FxColors.lime200);
  Text get lime300 => _copyWith(color: FxColors.lime300);
  Text get lime400 => _copyWith(color: FxColors.lime400);
  Text get lime500 => _copyWith(color: FxColors.lime500);
  Text get lime600 => _copyWith(color: FxColors.lime600);
  Text get lime700 => _copyWith(color: FxColors.lime700);
  Text get lime800 => _copyWith(color: FxColors.lime800);
  Text get lime900 => _copyWith(color: FxColors.lime900);

  ///Green Colors
  Text get green50 => _copyWith(color: FxColors.green50);
  Text get green100 => _copyWith(color: FxColors.green100);
  Text get green200 => _copyWith(color: FxColors.green200);
  Text get green300 => _copyWith(color: FxColors.green300);
  Text get green400 => _copyWith(color: FxColors.green400);
  Text get green500 => _copyWith(color: FxColors.green500);
  Text get green600 => _copyWith(color: FxColors.green600);
  Text get green700 => _copyWith(color: FxColors.green700);
  Text get green800 => _copyWith(color: FxColors.green800);
  Text get green900 => _copyWith(color: FxColors.green900);

  ///Emerald Colors
  Text get emerald50 => _copyWith(color: FxColors.emerald50);
  Text get emerald100 => _copyWith(color: FxColors.emerald100);
  Text get emerald200 => _copyWith(color: FxColors.emerald200);
  Text get emerald300 => _copyWith(color: FxColors.emerald300);
  Text get emerald400 => _copyWith(color: FxColors.emerald400);
  Text get emerald500 => _copyWith(color: FxColors.emerald500);
  Text get emerald600 => _copyWith(color: FxColors.emerald600);
  Text get emerald700 => _copyWith(color: FxColors.emerald700);
  Text get emerald800 => _copyWith(color: FxColors.emerald800);
  Text get emerald900 => _copyWith(color: FxColors.emerald900);

  ///Teal Colors
  Text get teal50 => _copyWith(color: FxColors.teal50);
  Text get teal100 => _copyWith(color: FxColors.teal100);
  Text get teal200 => _copyWith(color: FxColors.teal200);
  Text get teal300 => _copyWith(color: FxColors.teal300);
  Text get teal400 => _copyWith(color: FxColors.teal400);
  Text get teal500 => _copyWith(color: FxColors.teal500);
  Text get teal600 => _copyWith(color: FxColors.teal600);
  Text get teal700 => _copyWith(color: FxColors.teal700);
  Text get teal800 => _copyWith(color: FxColors.teal800);
  Text get teal900 => _copyWith(color: FxColors.teal900);

  ///Cyan Colors
  Text get cyan50 => _copyWith(color: FxColors.cyan50);
  Text get cyan100 => _copyWith(color: FxColors.cyan100);
  Text get cyan200 => _copyWith(color: FxColors.cyan200);
  Text get cyan300 => _copyWith(color: FxColors.cyan300);
  Text get cyan400 => _copyWith(color: FxColors.cyan400);
  Text get cyan500 => _copyWith(color: FxColors.cyan500);
  Text get cyan600 => _copyWith(color: FxColors.cyan600);
  Text get cyan700 => _copyWith(color: FxColors.cyan700);
  Text get cyan800 => _copyWith(color: FxColors.cyan800);
  Text get cyan900 => _copyWith(color: FxColors.cyan900);

  ///Light Blue Colors
  Text get lightBlue50 => _copyWith(color: FxColors.lightBlue50);
  Text get lightBlue100 => _copyWith(color: FxColors.lightBlue100);
  Text get lightBlue200 => _copyWith(color: FxColors.lightBlue200);
  Text get lightBlue300 => _copyWith(color: FxColors.lightBlue300);
  Text get lightBlue400 => _copyWith(color: FxColors.lightBlue400);
  Text get lightBlue500 => _copyWith(color: FxColors.lightBlue500);
  Text get lightBlue600 => _copyWith(color: FxColors.lightBlue600);
  Text get lightBlue700 => _copyWith(color: FxColors.lightBlue700);
  Text get lightBlue800 => _copyWith(color: FxColors.lightBlue800);
  Text get lightBlue900 => _copyWith(color: FxColors.lightBlue900);

  ///Blue Colors
  Text get blue50 => _copyWith(color: FxColors.blue50);
  Text get blue100 => _copyWith(color: FxColors.blue100);
  Text get blue200 => _copyWith(color: FxColors.blue200);
  Text get blue300 => _copyWith(color: FxColors.blue300);
  Text get blue400 => _copyWith(color: FxColors.blue400);
  Text get blue500 => _copyWith(color: FxColors.blue500);
  Text get blue600 => _copyWith(color: FxColors.blue600);
  Text get blue700 => _copyWith(color: FxColors.blue700);
  Text get blue800 => _copyWith(color: FxColors.blue800);
  Text get blue900 => _copyWith(color: FxColors.blue900);

  ///Indigo Colors
  Text get indigo50 => _copyWith(color: FxColors.indigo50);
  Text get indigo100 => _copyWith(color: FxColors.indigo100);
  Text get indigo200 => _copyWith(color: FxColors.indigo200);
  Text get indigo300 => _copyWith(color: FxColors.indigo300);
  Text get indigo400 => _copyWith(color: FxColors.indigo400);
  Text get indigo500 => _copyWith(color: FxColors.indigo500);
  Text get indigo600 => _copyWith(color: FxColors.indigo600);
  Text get indigo700 => _copyWith(color: FxColors.indigo700);
  Text get indigo800 => _copyWith(color: FxColors.indigo800);
  Text get indigo900 => _copyWith(color: FxColors.indigo900);

  ///Violet Colors
  Text get violet50 => _copyWith(color: FxColors.violet50);
  Text get violet100 => _copyWith(color: FxColors.violet100);
  Text get violet200 => _copyWith(color: FxColors.violet200);
  Text get violet300 => _copyWith(color: FxColors.violet300);
  Text get violet400 => _copyWith(color: FxColors.violet400);
  Text get violet500 => _copyWith(color: FxColors.violet500);
  Text get violet600 => _copyWith(color: FxColors.violet600);
  Text get violet700 => _copyWith(color: FxColors.violet700);
  Text get violet800 => _copyWith(color: FxColors.violet800);
  Text get violet900 => _copyWith(color: FxColors.violet900);

  ///Purple Colors
  Text get purple50 => _copyWith(color: FxColors.purple50);
  Text get purple100 => _copyWith(color: FxColors.purple100);
  Text get purple200 => _copyWith(color: FxColors.purple200);
  Text get purple300 => _copyWith(color: FxColors.purple300);
  Text get purple400 => _copyWith(color: FxColors.purple400);
  Text get purple500 => _copyWith(color: FxColors.purple500);
  Text get purple600 => _copyWith(color: FxColors.purple600);
  Text get purple700 => _copyWith(color: FxColors.purple700);
  Text get purple800 => _copyWith(color: FxColors.purple800);
  Text get purple900 => _copyWith(color: FxColors.purple900);

  ///Fuchsia Colors
  Text get fuchsia50 => _copyWith(color: FxColors.fuchsia50);
  Text get fuchsia100 => _copyWith(color: FxColors.fuchsia100);
  Text get fuchsia200 => _copyWith(color: FxColors.fuchsia200);
  Text get fuchsia300 => _copyWith(color: FxColors.fuchsia300);
  Text get fuchsia400 => _copyWith(color: FxColors.fuchsia400);
  Text get fuchsia500 => _copyWith(color: FxColors.fuchsia500);
  Text get fuchsia600 => _copyWith(color: FxColors.fuchsia600);
  Text get fuchsia700 => _copyWith(color: FxColors.fuchsia700);
  Text get fuchsia800 => _copyWith(color: FxColors.fuchsia800);
  Text get fuchsia900 => _copyWith(color: FxColors.fuchsia900);

  ///Pink Colors
  Text get pink50 => _copyWith(color: FxColors.pink50);
  Text get pink100 => _copyWith(color: FxColors.pink100);
  Text get pink200 => _copyWith(color: FxColors.pink200);
  Text get pink300 => _copyWith(color: FxColors.pink300);
  Text get pink400 => _copyWith(color: FxColors.pink400);
  Text get pink500 => _copyWith(color: FxColors.pink500);
  Text get pink600 => _copyWith(color: FxColors.pink600);
  Text get pink700 => _copyWith(color: FxColors.pink700);
  Text get pink800 => _copyWith(color: FxColors.pink800);
  Text get pink900 => _copyWith(color: FxColors.pink900);

  ///Rose Colors
  Text get rose50 => _copyWith(color: FxColors.rose50);
  Text get rose100 => _copyWith(color: FxColors.rose100);
  Text get rose200 => _copyWith(color: FxColors.rose200);
  Text get rose300 => _copyWith(color: FxColors.rose300);
  Text get rose400 => _copyWith(color: FxColors.rose400);
  Text get rose500 => _copyWith(color: FxColors.rose500);
  Text get rose600 => _copyWith(color: FxColors.rose600);
  Text get rose700 => _copyWith(color: FxColors.rose700);
  Text get rose800 => _copyWith(color: FxColors.rose800);
  Text get rose900 => _copyWith(color: FxColors.rose900);

  Text _copyWith({Color? color}) => Text(data!, style: TextStyle(color: color));
}
