import 'package:flutter/material.dart';

///Creates a fixed sqaure size box.
///
///Sets [width] and [height] parameters equal to given size
class FxSquareBox extends StatelessWidget {
  FxSquareBox(this.size, {this.child});

  ///Create square size box
  final double size;

  ///Create child widget
  final Widget? child;

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      width: size,
      height: size,
      child: child,
    );
  }
}

///Create Fixed size height box
class FxHBox extends StatelessWidget {
  FxHBox(this.height, {this.child});

  ///Create height box
  final double height;

  ///Create child widget
  final Widget? child;

  @override
  Widget build(BuildContext context) {
    return SizedBox(
      height: height.toDouble(),
      child: child,
    );
  }
}

///Create Fixed size width box
class FxWBox extends StatelessWidget {
  FxWBox(this.width, {this.child});

  ///Create width box
  final double width;

  ///Create child widget
  final Widget? child;

  @override
  Widget build(BuildContext context) {
    return SizedBox(width: width, child: child);
  }
}
